﻿/* Copyright (c) 2008 John Wells - http://www.codeplex.com/Johnnylightbulb/

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */

namespace JohnWells.GameDynamics.CD
{
    // .NET Fx
    using System.Diagnostics;

    // XNA
    using Microsoft.Xna.Framework;

    // Local
    using JohnWells.GameDynamics.Geometries;

    public sealed class BoxCollider : ICollider
    {
        public Contact? Collide(Box a, Box b)
        {
            #region Assertions
            Debug.Assert(a != null);
            Debug.Assert(b != null);
            #endregion

            throw new global::System.NotImplementedException();

            //var map = new SupportMap(a);

            //var extents = b.HalfExtents;
            //var v0 = new Vector3(-extents.X, -extents.Y, -extents.Z);
            //var v1 = new Vector3(+extents.X, -extents.Y, -extents.Z);
            //var v2 = new Vector3(-extents.X, +extents.Y, -extents.Z);
            //var v3 = new Vector3(+extents.X, +extents.Y, -extents.Z);
            //var v4 = new Vector3(-extents.X, -extents.Y, +extents.Z);
            //var v5 = new Vector3(+extents.X, -extents.Y, +extents.Z);
            //var v6 = new Vector3(-extents.X, +extents.Y, +extents.Z);
            //var v7 = new Vector3(+extents.X, +extents.Y, +extents.Z);

            //map.Support(v0.Transform(b.State));
        }

        #region ICollider Members
        public Contact? Detect(Body a, Body b)
        {
            return this.Collide(a as Box, b as Box);
        }
        #endregion
    }
}
